const { logInfo } = require("../../libs/utils")
const { join } = require('path');
const CiqlJson = require("ciql-json");
const Sequelize = require("sequelize");
const { writeCryptJson, readCryptJson } = require('../../libs/function');
const { cwd } = require('process');

function connect(connString, force, id) {
  return new Promise(async (resolve, reject) => {
    try {
      if (force) {
        writeCryptJson(connString, join(cwd(), ".ciql/keys/.db"))
        writeCryptJson(CiqlJson
          .create(readCryptJson(join(cwd(), ".ciql/data/.info")))
          .set("db", { connected: true, id })
          .getData(),
          join(cwd(), ".ciql/data/.info")
        )

        resolve("Forced Connection")

      } else {
        db = new Sequelize(connString.data, { logging: false, define: { freezeTableName: true } })
        logInfo("Waiting Connexion ...");
        db.authenticate()
          .then(() => {

            writeCryptJson(connString, join(cwd(), ".ciql/keys/.db"))
            writeCryptJson(CiqlJson
              .create(readCryptJson(join(cwd(), ".ciql/data/.info")))
              .set("db", { connected: true, id })
              .getData(),
              join(cwd(), ".ciql/data/.info")
            )

            resolve("database Connected")

          })
          .catch((err) => {
            reject(err.message)
          })
      }
    } catch (error) {
      reject(error.message)
    }
  })

}

module.exports = connect
