const fs = require('fs')
const { join } = require('path');
const CiqlJson = require("ciql-json");
const { readCryptJson, writeCryptJson } = require('../../libs/function');
const { cwd } = require('process');

function disconnect() {
  return new Promise(async (resolve, reject) => {
    try {

      if (fs.existsSync(join(process.env.CONFIG_PATH, 'keys', '.db'))) {
        fs.rmSync(join(process.env.CONFIG_PATH, 'keys', '.db'))

        writeCryptJson(
          CiqlJson
            .create(readCryptJson(join(cwd(), ".ciql/data/.info")))
            .set("db", { connected: false })
            .getData(),
          join(cwd(), ".ciql/data/.info")
        )

        resolve("Database disconnected")
      } else {
        reject("Any database connected")
      }

    } catch (error) {
      reject(error.message)
    }
  })

}

module.exports = disconnect
