const ciqlJSON = require("ciql-json")
const { join } = require("path")
const { readCryptJson, writeCryptJson } = require("../../libs/function")
const { cwd } = require("process")
const fs = require('fs')
const { createFolder, logInfo, logError } = require("../../libs/utils")
const { exec } = require('child_process')

function hook(hooks) {
    return new Promise(async (resolveOK, reject) => {
        try {



            let dataPath = join(cwd(), ".ciql", "data", ".hooks")
            let gitpath = join(cwd(), ".git", "hooks")
            let hooksPath = join(cwd(), "hooks")

            createFolder(hooksPath)

            let data = ciqlJSON.create(readCryptJson(dataPath))
            let allHooks = ciqlJSON.create(readCryptJson(dataPath)).remove('iat').getKeys()

            allHooks.forEach(hook => {

                let hookFile = join(hooksPath, hook + ".sh")
                let gitHookFile = join(gitpath, hook)

                if (hooks.includes(hook)) {

                    if (!fs.existsSync(hookFile)) {
                        fs.writeFileSync(hookFile, `#!/bin/sh`)
                    }

                    if (!fs.existsSync(gitHookFile)) {
                        fs.writeFileSync(gitHookFile, `#!/bin/sh\nsh "$(pwd)/hooks/${hook}.sh"`)
                        exec(`chmod a+x ${gitHookFile}`, { cwd: cwd() }, async (err, stdout, stderr) => {
                            if (err) {
                                logError(err.message)
                            }
                        })
                    }

                    data = data.set(hook, true)

                } else {

                    if (fs.existsSync(hookFile)) {
                        fs.rmSync(hookFile)
                    }

                    if (fs.existsSync(gitHookFile)) {
                        fs.rmSync(gitHookFile)
                    }

                    data = data.set(hook, false)

                }

            });

            let finalData = data.getData()

            writeCryptJson(finalData, dataPath)

            resolveOK("OK")
        } catch (error) {
            reject(error.message)
        }
    })
}

module.exports = hook
