const fs = require('fs')
const { join } = require('path')
const ciqlJSON = require("ciql-json")
const { cwd } = require('process')
const { writeCryptJson, readCryptJson } = require('../../libs/function')


function edit(name, description, author) {
    return new Promise(async (resolveOK, reject) => {
        try {

            writeCryptJson(
                ciqlJSON
                    .create(readCryptJson(join(cwd(), ".ciql/data/.info")))
                    .set("name", name)
                    .set("description", description)
                    .set("author", author)
                    .getData(),
                join(cwd(), ".ciql/data/.info")
            )

            ciqlJSON
                .open(join(cwd(), "package.json"))
                .set("name", name)
                .set("description", description)
                .set("author", author)
                .save()

            ciqlJSON
                .open(join(cwd(), "docs", "info.json"))
                .set("info.title", name)
                .set("info.description", description)
                .set("info.contact", author)
                .save()

            fs.writeFileSync(join(cwd(), ".env"), `PORT=3983\nAPI_NAME=${name}\nNODE_ENV=development`)


            resolveOK("Information Modified successfully")

        } catch (error) {
            console.log(error);
            reject(error.message)
        }
    })
}

module.exports = edit
