const ciqlJSON = require("ciql-json")
const { join } = require("path")
const moment = require("moment")
const table = require("tty-table")
const { readCryptJson } = require("../../libs/function")


function history() {
  return new Promise(async (resolveOK, reject) => {
    try {

      const header = [
        { value: "Server", color: "red" },
        { value: "Database" },
        { value: "Code version" },
        { value: "Date" }
      ]

      const rows = []
      const options = {
        borderStyle: "solid",
        borderColor: "blue",
        headerAlign: "center",
        headerColor: "cyan",
        align: "left",
        color: "white",
        width: "100%"
      }

      const jsonFile = readCryptJson(join('.ciql', 'data', '.history'))
      const histories = ciqlJSON.create(jsonFile).getData()
      const identifiants = ciqlJSON.create(jsonFile).getKeys()

      identifiants.forEach(v => {
        rows.push([
          histories[v]["server"],
          histories[v]["db"],
          histories[v]["version"],
          moment(histories[v]["date"]).format("ddd DD/MM/YYYY HH:mm:ss.SSS"),
        ])
      });

      console.log("\nDEployment history");
      console.log(table(header, rows, options).render());

      resolveOK("OK")
    } catch (error) {
      reject(error.message)
    }
  })
}

module.exports = history
