const CiqlJson = require("ciql-json")
const { writeCryptJson, readCryptJson } = require("../../libs/function")
const { join } = require('path')
const { cwd } = require("process")

function lock(pass) {
    return new Promise(async (resolveOK, reject) => {

        try {
            writeCryptJson(CiqlJson
                .create(readCryptJson(join(cwd(), ".ciql/data/.info")))
                .set("secure", { active: true, pass })
                .set("status", "locked")
                .getData(),
                join(cwd(), ".ciql/data/.info")
            )

            resolveOK("ciql project locked")
        } catch (error) {
            reject(error.message)
        }
    }
    )
}


module.exports = lock