const CiqlJson = require("ciql-json")
const { writeCryptJson, readCryptJson } = require("../../libs/function")
const { join } = require('path')
const { cwd } = require("process")

function unlock() {
    return new Promise(async (resolveOK, reject) => {

        try {

            const { node_env } = CiqlJson
                .create(readCryptJson(join(cwd(), ".ciql/data/.info")))
                .extract("{ node_env }")
                .getData()


            writeCryptJson(CiqlJson
                .create(readCryptJson(join(cwd(), ".ciql/data/.info")))
                .set("status", node_env === 'production' ? "built" : "generated")
                .getData(),
                join(cwd(), ".ciql/data/.info")
            )

            resolveOK("ciql project unlocked")
        } catch (error) {
            reject(error.message)
        }
    }
    )
}


module.exports = unlock