const ciqlJSON = require("ciql-json")
const { join } = require("path")
const { readCryptJson, writeCryptJson } = require("../../libs/function")
const generator = require('generate-password');
const { cwd } = require("process")

function add(tasks) {
    return new Promise(async (resolveOK, reject) => {
        try {
            let dataPath = join(cwd(), ".ciql", "data", ".todos")

            tasks.forEach(task => {
                let id = generator.generate({
                    length: 10,
                    uppercase: false,
                    symbols: false,
                    numbers: true
                });
                let data = ciqlJSON
                    .create(readCryptJson(dataPath))
                    .set(id, { task, start: new Date(), checked: false })
                    .getData()

                writeCryptJson(data, dataPath)
            });

            resolveOK("OK")
        } catch (error) {
            reject(error.message)
        }
    })
}

module.exports = add
