const ciqlJSON = require("ciql-json")
const { join } = require("path")
const { readCryptJson, writeCryptJson } = require("../../libs/function")
const { cwd } = require("process")


function check(endedTask) {
    return new Promise(async (resolveOK, reject) => {
        try {

            let dataPath = join(cwd(), ".ciql", "data", ".todos")
            let data = ciqlJSON
                .create(readCryptJson(dataPath))
                .getData()

            Object.values(endedTask).forEach(id => {
                data[id].end = new Date()
                data[id].checked = true
            });

            writeCryptJson(data, dataPath)

            resolveOK("OK")
        } catch (error) {
            reject(error.message)
        }
    })
}

module.exports = check
